<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>

</body>
<script>
    //subtask 1 : kiem tra mang
    function checkArray(paramArray) {
        return Array.isArray(paramArray);
    }

    var vResult = checkArray([1, 2, 3, 4]);
    console.log(vResult);

    //subtask 2 : tra ve phan tu thu n cua mang
    function subTask2(paramNum, paramArray) {
        if (paramNum < paramArray.length) {
            return paramArray[paramNum];
        } else {
            return null;
        }
    }

    var vTest = [1, 2, 3, 4, 5, 6];
    var vResult2 = subTask2(6, vTest);
    console.log(vResult2);

    //subtask 3 : sắp xếp giá trị các phần tử của mảng theo thứ tự tăng dần
    function sapXepThuTuTangDan(paramArray) {
        var vTg = 0;
        for (var i = 1; i < paramArray.length; i++) {
            for (var x = 0; x < paramArray.length; x++) {
                if(paramArray[i] < paramArray[x]){
                    vTg = paramArray[i];
                    paramArray[i] = paramArray[x];
                    paramArray[x] = vTg;
                }
            }
        }
    }

    var vTest = [3, 8, 7, 6, 5, -4, -3, 1, 2];
    console.log(vTest)
    sapXepThuTuTangDan(vTest);
    console.log(vTest);

    //subtask 4 : trả về vị trí của phần tử thứ n trong mảng
    function traVeViTri(paramNum, paramArray){
        for(var vI = 0 ; vI < paramArray.length; vI++){
            if(paramArray[vI] == paramNum){
                return vI;
            }            
        }
        return -1;
    }

    var vTest = [1,2,3,4,5,6];
    
    console.log(traVeViTri(7,vTest));

    //subtask  5 : nối 2 mảng
    function noiMang(paramArray1, paramArray2){
        var FinalArray = paramArray1.concat(paramArray2);
        return FinalArray;
    }

    var vArr1 = [1,2,3];
    var vArr2 = [4,5,6];
    var vArrFinal = noiMang(vArr1,vArr2);
    console.log(vArrFinal);


    //subtask 6 : lọc mảng trả về mảng chứa phần tử có giá trị
    function LocMang(paramArray){
        var vResult = [];
        for(var vI = 0 ; vI <paramArray.length; vI++){
            isNaN(paramArray[vI]);
            if(isNaN(paramArray[vI]) == false && paramArray[vI] > 0 || paramArray[vI] < 0){
                vResult = vResult.concat(paramArray[vI]);
            }
        }
        return vResult;
    }

    var vTest = [NaN, 0, 15, false, -22, '',undefined, 47, null];
    console.log(LocMang(vTest));


    //subtask 7 : bỏ phần tử có giá trị bằng n trong mảng cho trước
    function CatMang(paramNum, paramArray){

        // var index = paramArray.indexOf(paramNum);
        // if(index >-1){
        //     paramArray.splice(index,1);
        // }

        var newArr = paramArray.filter(item => item !== paramNum);
        return newArr;
    }

    var vTest = [2, 5, 9, 6];
    var vResult = CatMang(9,vTest);
    console.log(vResult);

    //subtask 8 : lấy random một phần tử bất kỳ trong mảng cho trước
    function RandomArray(paramArray){
        var RandomNum = paramArray[Math.floor(Math.random()*paramArray.length)];
        return RandomNum;
    }

    var vTest = [1,2,3,4,5,6,7,8,9,22,75,23,664,74,175];
    console.log(RandomArray(vTest));

    //subtask 9 : tạo một mảng gồm x phần tử có giá trị y
    function CreateArrayXY(paramX, paramY){
        var newArr =[];
        newArr.length = paramX;
        for(var vI = 0; vI < paramX; vI++){
            newArr[vI] = paramY;
        }
        return newArr;
    }

    console.log(CreateArrayXY(6,0));

    //subtask 10 : tạo một mảng gồm y số liên tiếp bắt đầu từ giá trị x
    function CreateArr(paramX, paramY){
        var newArr =[];
        newArr.length = paramY;
        for(var vI = 0; vI < paramY; vI++){
            newArr[vI] = paramX;
            paramX++;
        }
        return newArr;
    }

    console.log(CreateArr(1,4));

</script>

</html>